// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDPCaps.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDPCaps Component 
//
// "TDx_Play_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDPCaps.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Play_Library_Defns"
#pragma link "TDx_Play_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDPCaps*)
{
    new TDPCaps(NULL);
}
// --------------------------------------------------------------------------
namespace Tdpcaps
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDPCaps)};
        RegisterComponents("TDx_Play", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDPCaps::TDPCaps()
// Description: The default constructor for the TDPCaps object.
// --------------------------------------------------------------------------
__fastcall TDPCaps::TDPCaps(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDPCaps::~TDPCaps()
// Description: The destructor for the TDPCaps object.
// --------------------------------------------------------------------------
__fastcall TDPCaps::~TDPCaps()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDPCaps method or fget/fset. eg. 
//              DP_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDPCaps::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags indicating the capabilities 
//              supported for the player or session. 
//              The described effect applies when the flag is set. 
//              
//              TDx_Play::SendEx() capabilities will not be shown until the 
//              session has been created. 
// Flags:       DPCAPS_ASYNCCANCELALLSUPPORTED -
//                Only all pending asynchronous messages may be cancelled. 
//                
//                Attempting to cancel specific unsent messages will return 
//                DPERR_UNSUPPORTED. 
//              DPCAPS_ASYNCCANCELSUPPORTED -
//                All types of unsent message cancellation are supported, 
//                including cancellation of all unsent messages. 
//              DPCAPS_ASYNCSUPPORTED -
//                Asychronous messages are supported. 
//                
//                This allows the DPSEND_ASYNC flag to be used with 
//                TDx_Play::SendEx(), but only if the 
//                DPSESSION_DIRECTPLAYPROTOCOL flag was set when the session 
//                was created or the service provider supports asynchronous 
//                messaging. 
//              DPCAPS_ENCRYPTIONSUPPORTED -
//                Support for message encryption is available. 
//                
//                This means this is a secure session or the service provider 
//                can encrypt messages. 
//              DPCAPS_GROUPOPTIMIZED -
//                Support for optimized group multicast messaging by the 
//                service provider is available. 
//              DPCAPS_GUARANTEEDOPTIMIZED -
//                Support for guaranteed message delivery by the service 
//                provider is available. 
//              DPCAPS_GUARANTEEDSUPPORTED -
//                Support for guaranteed message delivery by the service 
//                provider or DirectPlay emulation is available. 
//              DPCAPS_ISHOST -
//                This object is the session host. 
//              DPCAPS_KEEPALIVEOPTIMIZED -
//                Support for detecting session connection loss by the 
//                service provider is available. 
//              DPCAPS_SENDPRIORITYSUPPORTED -
//                Sending prioritized messages with TDx_Play::SendEx() is 
//                supported. 
//              DPCAPS_SENDTIMEOUTSUPPORTED -
//                Sending messages with a timeout specified by 
//                TDx_Play::SendEx() is supported. 
//              DPCAPS_SIGNINGSUPPORTED -
//                Support for message authentication is available. 
//                
//                This means this is a secure session or the service provider 
//                can encrypt messages. 
// --------------------------------------------------------------------------
dword __fastcall TDPCaps::FGetFlags()
{
return fDPCAPS.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::FSetFlags( dword pFlags )
{
fDPCAPS.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    HeaderLength
// Description: The HeaderLength property defines the size, in bytes, of the 
//              player message header. 
//              
//              The size of the header will vary depending on which service 
//              provider is in use. 
// --------------------------------------------------------------------------
dword __fastcall TDPCaps::FGetHeaderLength()
{
return fDPCAPS.dwHeaderLength;
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::FSetHeaderLength( dword pHeaderLength )
{
fDPCAPS.dwHeaderLength = pHeaderLength;
}
// --------------------------------------------------------------------------
// Property:    HundredBaud
// Description: The HundredBaud property defines the bandwidth, in multiples 
//              of 100 bits per second. 
//              
//              For example, for a 28.8 kbps connection this property would 
//              have a value of 288. 
// --------------------------------------------------------------------------
dword __fastcall TDPCaps::FGetHundredBaud()
{
return fDPCAPS.dwHundredBaud;
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::FSetHundredBaud( dword pHundredBaud )
{
fDPCAPS.dwHundredBaud = pHundredBaud;
}
// --------------------------------------------------------------------------
// Property:    Latency
// Description: The Latency property defines a latency estimate, in 
//              milliseconds, provided by the service provider. 
//              
//              When this value is 0 it means an estimate cannot be provided. 
//              Latency may differ for the use of guaranteed or nonguaranteed 
//              message delivery. 
// --------------------------------------------------------------------------
dword __fastcall TDPCaps::FGetLatency()
{
return fDPCAPS.dwLatency;
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::FSetLatency( dword pLatency )
{
fDPCAPS.dwLatency = pLatency;
}
// --------------------------------------------------------------------------
// Property:    MaxBufferSize
// Description: The MaxBufferSize property defines the maximum packet size, 
//              in bytes, for this service provider. 
//              
//              Messages larger than this size will be sent by using multiple 
//              packet. 
// --------------------------------------------------------------------------
dword __fastcall TDPCaps::FGetMaxBufferSize()
{
return fDPCAPS.dwMaxBufferSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::FSetMaxBufferSize( dword pMaxBufferSize )
{
fDPCAPS.dwMaxBufferSize = pMaxBufferSize;
}
// --------------------------------------------------------------------------
// Property:    MaxLocalPlayers
// Description: The MaxLocalPlayers property defines the maximum number of 
//              local players supported by the session. 
//              
//              Local players are players that are located on the same 
//              computer. 
// --------------------------------------------------------------------------
dword __fastcall TDPCaps::FGetMaxLocalPlayers()
{
return fDPCAPS.dwMaxLocalPlayers;
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::FSetMaxLocalPlayers( dword pMaxLocalPlayers )
{
fDPCAPS.dwMaxLocalPlayers = pMaxLocalPlayers;
}
// --------------------------------------------------------------------------
// Property:    MaxPlayers
// Description: The MaxPlayers property defines the maximum number of local 
//              and remote players supported for one session. 
// --------------------------------------------------------------------------
dword __fastcall TDPCaps::FGetMaxPlayers()
{
return fDPCAPS.dwMaxPlayers;
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::FSetMaxPlayers( dword pMaxPlayers )
{
fDPCAPS.dwMaxPlayers = pMaxPlayers;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDPCaps::FGetSize()
{
return fDPCAPS.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::FSetSize( dword pSize )
{
fDPCAPS.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Timeout
// Description: The Timeout property defines the default time the service 
//              provider will wait for a message reply. 
// --------------------------------------------------------------------------
dword __fastcall TDPCaps::FGetTimeout()
{
return fDPCAPS.dwTimeout;
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::FSetTimeout( dword pTimeout )
{
fDPCAPS.dwTimeout = pTimeout;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDPCaps's internal DPCAPS structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDPCaps::Clear()
{
fErrorValue = DP_OK;
fDPCAPS.dwFlags = 0;
fDPCAPS.dwHeaderLength = 0;
fDPCAPS.dwHundredBaud = 0;
fDPCAPS.dwLatency = 0;
fDPCAPS.dwMaxBufferSize = 0;
fDPCAPS.dwMaxLocalPlayers = 0;
fDPCAPS.dwMaxPlayers = 0;
fDPCAPS.dwSize = sizeof(DPCAPS);
fDPCAPS.dwTimeout = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DPCAPS* __fastcall TDPCaps::FGetInternal_DPCAPS_Ptr()
{
return &fDPCAPS;
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::FSetInternal_DPCAPS( DPCAPS* pDPCAPS )
{
if (pDPCAPS==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDPCaps::FSetInternal_DPCAPS()", "TDX_ERROR", "The supplied DPCAPS* was NULL" );
    return;
    }

CopyMemory( &fDPCAPS, pDPCAPS, sizeof(DPCAPS) );
Internal_DPCAPS_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::Internal_DPCAPS_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDPCaps_Flags_Set<> of the flags in the 
//              current fDPCAPS.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDPCaps_Flags_Set __fastcall TDPCaps::FGetFlags_()
{
TDPCaps_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDPCAPS.dwFlags & DPCAPS_ASYNCCANCELALLSUPPORTED) TempFlags_ = TempFlags_ << dpcaps_asynccancelallsupported;
if (fDPCAPS.dwFlags & DPCAPS_ASYNCCANCELSUPPORTED) TempFlags_ = TempFlags_ << dpcaps_asynccancelsupported;
if (fDPCAPS.dwFlags & DPCAPS_ASYNCSUPPORTED) TempFlags_ = TempFlags_ << dpcaps_asyncsupported;
if (fDPCAPS.dwFlags & DPCAPS_ENCRYPTIONSUPPORTED) TempFlags_ = TempFlags_ << dpcaps_encryptionsupported;
if (fDPCAPS.dwFlags & DPCAPS_GROUPOPTIMIZED) TempFlags_ = TempFlags_ << dpcaps_groupoptimized;
if (fDPCAPS.dwFlags & DPCAPS_GUARANTEEDOPTIMIZED) TempFlags_ = TempFlags_ << dpcaps_guaranteedoptimized;
if (fDPCAPS.dwFlags & DPCAPS_GUARANTEEDSUPPORTED) TempFlags_ = TempFlags_ << dpcaps_guaranteedsupported;
if (fDPCAPS.dwFlags & DPCAPS_ISHOST) TempFlags_ = TempFlags_ << dpcaps_ishost;
if (fDPCAPS.dwFlags & DPCAPS_KEEPALIVEOPTIMIZED) TempFlags_ = TempFlags_ << dpcaps_keepaliveoptimized;
if (fDPCAPS.dwFlags & DPCAPS_SENDPRIORITYSUPPORTED) TempFlags_ = TempFlags_ << dpcaps_sendprioritysupported;
if (fDPCAPS.dwFlags & DPCAPS_SENDTIMEOUTSUPPORTED) TempFlags_ = TempFlags_ << dpcaps_sendtimeoutsupported;
if (fDPCAPS.dwFlags & DPCAPS_SIGNINGSUPPORTED) TempFlags_ = TempFlags_ << dpcaps_signingsupported;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDPCaps::FSetFlags_( TDPCaps_Flags_Set pFlags_ )
{
fDPCAPS.dwFlags = 0;
if (pFlags_.Contains(dpcaps_asynccancelallsupported)) fDPCAPS.dwFlags |= DPCAPS_ASYNCCANCELALLSUPPORTED;
if (pFlags_.Contains(dpcaps_asynccancelsupported)) fDPCAPS.dwFlags |= DPCAPS_ASYNCCANCELSUPPORTED;
if (pFlags_.Contains(dpcaps_asyncsupported)) fDPCAPS.dwFlags |= DPCAPS_ASYNCSUPPORTED;
if (pFlags_.Contains(dpcaps_encryptionsupported)) fDPCAPS.dwFlags |= DPCAPS_ENCRYPTIONSUPPORTED;
if (pFlags_.Contains(dpcaps_groupoptimized)) fDPCAPS.dwFlags |= DPCAPS_GROUPOPTIMIZED;
if (pFlags_.Contains(dpcaps_guaranteedoptimized)) fDPCAPS.dwFlags |= DPCAPS_GUARANTEEDOPTIMIZED;
if (pFlags_.Contains(dpcaps_guaranteedsupported)) fDPCAPS.dwFlags |= DPCAPS_GUARANTEEDSUPPORTED;
if (pFlags_.Contains(dpcaps_ishost)) fDPCAPS.dwFlags |= DPCAPS_ISHOST;
if (pFlags_.Contains(dpcaps_keepaliveoptimized)) fDPCAPS.dwFlags |= DPCAPS_KEEPALIVEOPTIMIZED;
if (pFlags_.Contains(dpcaps_sendprioritysupported)) fDPCAPS.dwFlags |= DPCAPS_SENDPRIORITYSUPPORTED;
if (pFlags_.Contains(dpcaps_sendtimeoutsupported)) fDPCAPS.dwFlags |= DPCAPS_SENDTIMEOUTSUPPORTED;
if (pFlags_.Contains(dpcaps_signingsupported)) fDPCAPS.dwFlags |= DPCAPS_SIGNINGSUPPORTED;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDPCaps::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDPCaps::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDPCAPS.dwFlags & DPCAPS_ASYNCCANCELALLSUPPORTED) fFlags_Strings->Add("DPCAPS_ASYNCCANCELALLSUPPORTED");
if (fDPCAPS.dwFlags & DPCAPS_ASYNCCANCELSUPPORTED) fFlags_Strings->Add("DPCAPS_ASYNCCANCELSUPPORTED");
if (fDPCAPS.dwFlags & DPCAPS_ASYNCSUPPORTED) fFlags_Strings->Add("DPCAPS_ASYNCSUPPORTED");
if (fDPCAPS.dwFlags & DPCAPS_ENCRYPTIONSUPPORTED) fFlags_Strings->Add("DPCAPS_ENCRYPTIONSUPPORTED");
if (fDPCAPS.dwFlags & DPCAPS_GROUPOPTIMIZED) fFlags_Strings->Add("DPCAPS_GROUPOPTIMIZED");
if (fDPCAPS.dwFlags & DPCAPS_GUARANTEEDOPTIMIZED) fFlags_Strings->Add("DPCAPS_GUARANTEEDOPTIMIZED");
if (fDPCAPS.dwFlags & DPCAPS_GUARANTEEDSUPPORTED) fFlags_Strings->Add("DPCAPS_GUARANTEEDSUPPORTED");
if (fDPCAPS.dwFlags & DPCAPS_ISHOST) fFlags_Strings->Add("DPCAPS_ISHOST");
if (fDPCAPS.dwFlags & DPCAPS_KEEPALIVEOPTIMIZED) fFlags_Strings->Add("DPCAPS_KEEPALIVEOPTIMIZED");
if (fDPCAPS.dwFlags & DPCAPS_SENDPRIORITYSUPPORTED) fFlags_Strings->Add("DPCAPS_SENDPRIORITYSUPPORTED");
if (fDPCAPS.dwFlags & DPCAPS_SENDTIMEOUTSUPPORTED) fFlags_Strings->Add("DPCAPS_SENDTIMEOUTSUPPORTED");
if (fDPCAPS.dwFlags & DPCAPS_SIGNINGSUPPORTED) fFlags_Strings->Add("DPCAPS_SIGNINGSUPPORTED");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
