// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDPChat.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDPChat Component 
//
// "TDx_Play_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDPChat.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Play_Library_Defns"
#pragma link "TDx_Play_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDPChat*)
{
    new TDPChat(NULL);
}
// --------------------------------------------------------------------------
namespace Tdpchat
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDPChat)};
        RegisterComponents("TDx_Play", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDPChat::TDPChat()
// Description: The default constructor for the TDPChat object.
// --------------------------------------------------------------------------
__fastcall TDPChat::TDPChat(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDPChat::~TDPChat()
// Description: The destructor for the TDPChat object.
// --------------------------------------------------------------------------
__fastcall TDPChat::~TDPChat()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDPChat method or fget/fset. eg. 
//              DP_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDPChat::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDPChat::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Message
// Description: The Message property references the  message being sent, 
//              stored as a Unicode string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPChat::FGetMessage()
{
if ((LPWSTR)fMessage.c_str()!=fDPCHAT.lpszMessage)
    fMessage = fDPCHAT.lpszMessage;
return fMessage;
}
// --------------------------------------------------------------------------
void __fastcall TDPChat::FSetMessage( AnsiString pMessage )
{
fMessage = pMessage;
fDPCHAT.lpszMessage = (LPWSTR) fMessage.c_str();
}
// --------------------------------------------------------------------------
// Property:    MessageA
// Description: The Message property references the  message being sent, 
//              stored as an ANSI string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPChat::FGetMessageA()
{
if ((LPSTR)fMessageA.c_str()!=fDPCHAT.lpszMessageA)
    fMessageA = fDPCHAT.lpszMessageA;
return fMessageA;
}
// --------------------------------------------------------------------------
void __fastcall TDPChat::FSetMessageA( AnsiString pMessageA )
{
fMessageA = pMessageA;
fDPCHAT.lpszMessageA = (LPSTR) fMessageA.c_str();
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DPCHAT structure. 
// --------------------------------------------------------------------------
dword __fastcall TDPChat::FGetSize()
{
return fDPCHAT.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPChat::FSetSize( dword pSize )
{
fDPCHAT.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDPChat's internal DPCHAT structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDPChat::Clear()
{
fErrorValue = DP_OK;
fDPCHAT.dwSize = sizeof(DPCHAT);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DPCHAT* __fastcall TDPChat::FGetInternal_DPCHAT_Ptr()
{
return &fDPCHAT;
}
// --------------------------------------------------------------------------
void __fastcall TDPChat::FSetInternal_DPCHAT( DPCHAT* pDPCHAT )
{
if (pDPCHAT==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDPChat::FSetInternal_DPCHAT()", "TDX_ERROR", "The supplied DPCHAT* was NULL" );
    return;
    }

CopyMemory( &fDPCHAT, pDPCHAT, sizeof(DPCHAT) );
Internal_DPCHAT_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDPChat::Internal_DPCHAT_Update()
{
}

// --------------------------------------------------------------------------
