// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDPComPortAddress.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDPComPortAddress 
//               Component 
//
// "TDx_Play_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDPComPortAddress.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Play_Library_Defns"
#pragma link "TDx_Play_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDPComPortAddress*)
{
    new TDPComPortAddress(NULL);
}
// --------------------------------------------------------------------------
namespace Tdpcomportaddress
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDPComPortAddress)};
        RegisterComponents("TDx_Play", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDPComPortAddress::TDPComPortAddress()
// Description: The default constructor for the TDPComPortAddress object.
// --------------------------------------------------------------------------
__fastcall TDPComPortAddress::TDPComPortAddress(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDPComPortAddress::~TDPComPortAddress()
// Description: The destructor for the TDPComPortAddress object.
// --------------------------------------------------------------------------
__fastcall TDPComPortAddress::~TDPComPortAddress()
{
}
// --------------------------------------------------------------------------
// Property:    BaudRate
// Description: The BaudRate property specifies the baud rate of the com 
//              port. 
//              
//              The possible values are : 
//              
//              CBR_110 
//              CBR_300 
//              CBR_600   
//              CBR_1200 
//              CBR_2400 
//              CBR_4800   
//              CBR_9600 
//              CBR_14400 
//              CBR_19200   
//              CBR_38400 
//              CBR_56000 
//              CBR_57600   
//              CBR_115200 
//              CBR_128000 
//              CBR_256000   
//              
// --------------------------------------------------------------------------
dword __fastcall TDPComPortAddress::FGetBaudRate()
{
return fDPCOMPORTADDRESS.dwBaudRate;
}
// --------------------------------------------------------------------------
void __fastcall TDPComPortAddress::FSetBaudRate( dword pBaudRate )
{
fDPCOMPORTADDRESS.dwBaudRate = pBaudRate;
}
// --------------------------------------------------------------------------
// Property:    ComPort
// Description: The ComPort property defines which COM port is to be used. 
//              
//              This property can contain a value of 1, 2, 3, or 4. 
// --------------------------------------------------------------------------
dword __fastcall TDPComPortAddress::FGetComPort()
{
return fDPCOMPORTADDRESS.dwComPort;
}
// --------------------------------------------------------------------------
void __fastcall TDPComPortAddress::FSetComPort( dword pComPort )
{
fDPCOMPORTADDRESS.dwComPort = pComPort;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDPComPortAddress method or 
//              fget/fset. eg. DP_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDPComPortAddress::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDPComPortAddress::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    FlowControl
// Description: The FlowControl property defines which method of flow control 
//              is being used on the COM port. 
//              
//              The possible values are: 
//              
//              DPCPA_NOFLOW   No Flow Control. 
//              DPCPA_DTRFLOW  Hardware DTR flow control. 
//              DPCPA_RTSFLOW   Hardware RTS flow control 
//              DPCPA_RTSDTRFLOW  Hardware RTS and DTR flow control. 
//              DPCPA_XONXOFFFLOW  Software XON/XOFF flow control. 
// --------------------------------------------------------------------------
dword __fastcall TDPComPortAddress::FGetFlowControl()
{
return fDPCOMPORTADDRESS.dwFlowControl;
}
// --------------------------------------------------------------------------
void __fastcall TDPComPortAddress::FSetFlowControl( dword pFlowControl )
{
fDPCOMPORTADDRESS.dwFlowControl = pFlowControl;
}
// --------------------------------------------------------------------------
// Property:    Parity
// Description: The Parity property defines the COM port parity being used. 
//              
//              The possible values are: 
//              
//              NOPARITY 
//              ODDPARITY 
//              EVENPARITY 
//              MARKPARITY 
// --------------------------------------------------------------------------
dword __fastcall TDPComPortAddress::FGetParity()
{
return fDPCOMPORTADDRESS.dwParity;
}
// --------------------------------------------------------------------------
void __fastcall TDPComPortAddress::FSetParity( dword pParity )
{
fDPCOMPORTADDRESS.dwParity = pParity;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DPCOMPORTADDRESS structure. 
// --------------------------------------------------------------------------
dword __fastcall TDPComPortAddress::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPComPortAddress::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    StopBits
// Description: The StopBits property defines the number of stop bits the com 
//              port uses. 
//              
//              The possible values are : 
//              
//              ONESTOPBIT 
//              ONE5STOPBITS 
//              TWOSTOPBITS 
// --------------------------------------------------------------------------
dword __fastcall TDPComPortAddress::FGetStopBits()
{
return fDPCOMPORTADDRESS.dwStopBits;
}
// --------------------------------------------------------------------------
void __fastcall TDPComPortAddress::FSetStopBits( dword pStopBits )
{
fDPCOMPORTADDRESS.dwStopBits = pStopBits;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDPComPortAddress's internal DPCOMPORTADDRESS structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDPComPortAddress::Clear()
{
fDPCOMPORTADDRESS.dwBaudRate = 0;
fDPCOMPORTADDRESS.dwComPort = 0;
fErrorValue = DP_OK;
fDPCOMPORTADDRESS.dwFlowControl = 0;
fDPCOMPORTADDRESS.dwParity = 0;
fSize = sizeof(DPCOMPORTADDRESS);
fDPCOMPORTADDRESS.dwStopBits = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DPCOMPORTADDRESS* __fastcall TDPComPortAddress::FGetInternal_DPCOMPORTADDRESS_Ptr()
{
return &fDPCOMPORTADDRESS;
}
// --------------------------------------------------------------------------
void __fastcall TDPComPortAddress::FSetInternal_DPCOMPORTADDRESS( DPCOMPORTADDRESS* pDPCOMPORTADDRESS )
{
if (pDPCOMPORTADDRESS==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDPComPortAddress::FSetInternal_DPCOMPORTADDRESS()", "TDX_ERROR", "The supplied DPCOMPORTADDRESS* was NULL" );
    return;
    }

CopyMemory( &fDPCOMPORTADDRESS, pDPCOMPORTADDRESS, sizeof(DPCOMPORTADDRESS) );
Internal_DPCOMPORTADDRESS_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDPComPortAddress::Internal_DPCOMPORTADDRESS_Update()
{
}

// --------------------------------------------------------------------------
