// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDPCredentials.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDPCredentials Component 
//
// "TDx_Play_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDPCredentials.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Play_Library_Defns"
#pragma link "TDx_Play_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDPCredentials*)
{
    new TDPCredentials(NULL);
}
// --------------------------------------------------------------------------
namespace Tdpcredentials
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDPCredentials)};
        RegisterComponents("TDx_Play", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDPCredentials::TDPCredentials()
// Description: The default constructor for the TDPCredentials object.
// --------------------------------------------------------------------------
__fastcall TDPCredentials::TDPCredentials(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDPCredentials::~TDPCredentials()
// Description: The destructor for the TDPCredentials object.
// --------------------------------------------------------------------------
__fastcall TDPCredentials::~TDPCredentials()
{
}
// --------------------------------------------------------------------------
// Property:    Domain
// Description: The Domain property references the domain to be authenticated 
//              by the server, stored as a unicode string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPCredentials::FGetDomain()
{
if ((LPWSTR)fDomain.c_str()!=fDPCREDENTIALS.lpszDomain)
    fDomain = fDPCREDENTIALS.lpszDomain;
return fDomain;
}
// --------------------------------------------------------------------------
void __fastcall TDPCredentials::FSetDomain( AnsiString pDomain )
{
fDomain = pDomain;
fDPCREDENTIALS.lpszDomain = (LPWSTR) fDomain.c_str();
}
// --------------------------------------------------------------------------
// Property:    DomainA
// Description: The DomainA property references the domain to be 
//              authenticated by the server, stored as an ANSI string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPCredentials::FGetDomainA()
{
if ((LPSTR)fDomainA.c_str()!=fDPCREDENTIALS.lpszDomainA)
    fDomainA = fDPCREDENTIALS.lpszDomainA;
return fDomainA;
}
// --------------------------------------------------------------------------
void __fastcall TDPCredentials::FSetDomainA( AnsiString pDomainA )
{
fDomainA = pDomainA;
fDPCREDENTIALS.lpszDomainA = (LPSTR) fDomainA.c_str();
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDPCredentials method or fget/fset. 
//              eg. DP_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDPCredentials::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDPCredentials::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Password
// Description: The Password property references the password to be 
//              authenticated by the server, stored as a unicode string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPCredentials::FGetPassword()
{
if ((LPWSTR)fPassword.c_str()!=fDPCREDENTIALS.lpszPassword)
    fPassword = fDPCREDENTIALS.lpszPassword;
return fPassword;
}
// --------------------------------------------------------------------------
void __fastcall TDPCredentials::FSetPassword( AnsiString pPassword )
{
fPassword = pPassword;
fDPCREDENTIALS.lpszPassword = (LPWSTR) fPassword.c_str();
}
// --------------------------------------------------------------------------
// Property:    PasswordA
// Description: The PasswordA property references the password to be 
//              authenticated by the server, stored as an ANSI string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPCredentials::FGetPasswordA()
{
if ((LPSTR)fPasswordA.c_str()!=fDPCREDENTIALS.lpszPasswordA)
    fPasswordA = fDPCREDENTIALS.lpszPasswordA;
return fPasswordA;
}
// --------------------------------------------------------------------------
void __fastcall TDPCredentials::FSetPasswordA( AnsiString pPasswordA )
{
fPasswordA = pPasswordA;
fDPCREDENTIALS.lpszPasswordA = (LPSTR) fPasswordA.c_str();
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DPCREDENTIALS structure. 
// --------------------------------------------------------------------------
dword __fastcall TDPCredentials::FGetSize()
{
return fDPCREDENTIALS.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPCredentials::FSetSize( dword pSize )
{
fDPCREDENTIALS.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Username
// Description: The UserName property references the username to be 
//              authenticated by the server, stored as a unicode string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPCredentials::FGetUsername()
{
if ((LPWSTR)fUsername.c_str()!=fDPCREDENTIALS.lpszUsername)
    fUsername = fDPCREDENTIALS.lpszUsername;
return fUsername;
}
// --------------------------------------------------------------------------
void __fastcall TDPCredentials::FSetUsername( AnsiString pUsername )
{
fUsername = pUsername;
fDPCREDENTIALS.lpszUsername = (LPWSTR) fUsername.c_str();
}
// --------------------------------------------------------------------------
// Property:    UsernameA
// Description: The UserNameA property references the username to be 
//              authenticated by the server, stored as an ANSI string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPCredentials::FGetUsernameA()
{
if ((LPSTR)fUsernameA.c_str()!=fDPCREDENTIALS.lpszUsernameA)
    fUsernameA = fDPCREDENTIALS.lpszUsernameA;
return fUsernameA;
}
// --------------------------------------------------------------------------
void __fastcall TDPCredentials::FSetUsernameA( AnsiString pUsernameA )
{
fUsernameA = pUsernameA;
fDPCREDENTIALS.lpszUsernameA = (LPSTR) fUsernameA.c_str();
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDPCredentials's internal DPCREDENTIALS structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDPCredentials::Clear()
{
fErrorValue = DP_OK;
fDPCREDENTIALS.dwSize = sizeof(DPCREDENTIALS);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DPCREDENTIALS* __fastcall TDPCredentials::FGetInternal_DPCREDENTIALS_Ptr()
{
return &fDPCREDENTIALS;
}
// --------------------------------------------------------------------------
void __fastcall TDPCredentials::FSetInternal_DPCREDENTIALS( DPCREDENTIALS* pDPCREDENTIALS )
{
if (pDPCREDENTIALS==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDPCredentials::FSetInternal_DPCREDENTIALS()", "TDX_ERROR", "The supplied DPCREDENTIALS* was NULL" );
    return;
    }

CopyMemory( &fDPCREDENTIALS, pDPCREDENTIALS, sizeof(DPCREDENTIALS) );
Internal_DPCREDENTIALS_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDPCredentials::Internal_DPCREDENTIALS_Update()
{
}

// --------------------------------------------------------------------------
