// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDPName.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDPName Component 
//
// "TDx_Play_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDPName.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Play_Library_Defns"
#pragma link "TDx_Play_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDPName*)
{
    new TDPName(NULL);
}
// --------------------------------------------------------------------------
namespace Tdpname
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDPName)};
        RegisterComponents("TDx_Play", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDPName::TDPName()
// Description: The default constructor for the TDPName object.
// --------------------------------------------------------------------------
__fastcall TDPName::TDPName(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDPName::~TDPName()
// Description: The destructor for the TDPName object.
// --------------------------------------------------------------------------
__fastcall TDPName::~TDPName()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDPName method or fget/fset. eg. 
//              DP_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDPName::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDPName::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    LongName
// Description: The LongName property references the long, or formal name, of 
//              a player or group, stored as a unicode string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPName::FGetLongName()
{
if ((LPWSTR)fLongName.c_str()!=fDPNAME.lpszLongName)
    fLongName = fDPNAME.lpszLongName;
return fLongName;
}
// --------------------------------------------------------------------------
void __fastcall TDPName::FSetLongName( AnsiString pLongName )
{
fLongName = pLongName;
fDPNAME.lpszLongName = (LPWSTR) fLongName.c_str();
}
// --------------------------------------------------------------------------
// Property:    LongNameA
// Description: The LongName property references the long, or formal name, of 
//              a player or group, stored as an ANSI string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPName::FGetLongNameA()
{
if ((LPSTR)fLongNameA.c_str()!=fDPNAME.lpszLongNameA)
    fLongNameA = fDPNAME.lpszLongNameA;
return fLongNameA;
}
// --------------------------------------------------------------------------
void __fastcall TDPName::FSetLongNameA( AnsiString pLongNameA )
{
fLongNameA = pLongNameA;
fDPNAME.lpszLongNameA = (LPSTR) fLongNameA.c_str();
}
// --------------------------------------------------------------------------
// Property:    ShortName
// Description: The ShortName property references the short, or friendly 
//              name, of a player or group, stored as a unicode string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPName::FGetShortName()
{
if ((LPWSTR)fShortName.c_str()!=fDPNAME.lpszShortName)
    fShortName = fDPNAME.lpszShortName;
return fShortName;
}
// --------------------------------------------------------------------------
void __fastcall TDPName::FSetShortName( AnsiString pShortName )
{
fShortName = pShortName;
fDPNAME.lpszShortName = (LPWSTR) fShortName.c_str();
}
// --------------------------------------------------------------------------
// Property:    ShortNameA
// Description: The ShortNameA property references the short, or friendly 
//              name, of a player or group, stored as an ANSI string. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPName::FGetShortNameA()
{
if ((LPSTR)fShortNameA.c_str()!=fDPNAME.lpszShortNameA)
    fShortNameA = fDPNAME.lpszShortNameA;
return fShortNameA;
}
// --------------------------------------------------------------------------
void __fastcall TDPName::FSetShortNameA( AnsiString pShortNameA )
{
fShortNameA = pShortNameA;
fDPNAME.lpszShortNameA = (LPSTR) fShortNameA.c_str();
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DPNAME structure. 
// --------------------------------------------------------------------------
dword __fastcall TDPName::FGetSize()
{
return fDPNAME.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPName::FSetSize( dword pSize )
{
fDPNAME.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDPName's internal DPNAME structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDPName::Clear()
{
fErrorValue = DP_OK;
fDPNAME.dwSize = sizeof(DPNAME);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DPNAME* __fastcall TDPName::FGetInternal_DPNAME_Ptr()
{
return &fDPNAME;
}
// --------------------------------------------------------------------------
void __fastcall TDPName::FSetInternal_DPNAME( DPNAME* pDPNAME )
{
if (pDPNAME==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDPName::FSetInternal_DPNAME()", "TDX_ERROR", "The supplied DPNAME* was NULL" );
    return;
    }

CopyMemory( &fDPNAME, pDPNAME, sizeof(DPNAME) );
Internal_DPNAME_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDPName::Internal_DPNAME_Update()
{
}

// --------------------------------------------------------------------------
