// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDPSecurityDesc.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDPSecurityDesc 
//               Component 
//
// "TDx_Play_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDPSecurityDesc.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Play_Library_Defns"
#pragma link "TDx_Play_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDPSecurityDesc*)
{
    new TDPSecurityDesc(NULL);
}
// --------------------------------------------------------------------------
namespace Tdpsecuritydesc
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDPSecurityDesc)};
        RegisterComponents("TDx_Play", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDPSecurityDesc::TDPSecurityDesc()
// Description: The default constructor for the TDPSecurityDesc object.
// --------------------------------------------------------------------------
__fastcall TDPSecurityDesc::TDPSecurityDesc(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDPSecurityDesc::~TDPSecurityDesc()
// Description: The destructor for the TDPSecurityDesc object.
// --------------------------------------------------------------------------
__fastcall TDPSecurityDesc::~TDPSecurityDesc()
{
}
// --------------------------------------------------------------------------
// Property:    CAPIProvider
// Description: The CAPIProvider property references a unicode string 
//              identifying the CryptoAPI package to use for cryptography 
//              services. 
//              
//              Set NULL to use the default CryptoAPI package, Microsoft RSA 
//              Base Cryptographic Provider v. 1.0. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPSecurityDesc::FGetCAPIProvider()
{
if ((LPWSTR)fCAPIProvider.c_str()!=fDPSECURITYDESC.lpszCAPIProvider)
    fCAPIProvider = fDPSECURITYDESC.lpszCAPIProvider;
return fCAPIProvider;
}
// --------------------------------------------------------------------------
void __fastcall TDPSecurityDesc::FSetCAPIProvider( AnsiString pCAPIProvider )
{
fCAPIProvider = pCAPIProvider;
fDPSECURITYDESC.lpszCAPIProvider = (LPWSTR) fCAPIProvider.c_str();
}
// --------------------------------------------------------------------------
// Property:    CAPIProviderA
// Description: The CAPIProviderA property references an ANSI string 
//              identifying the CryptoAPI package to use for cryptography 
//              services. 
//              
//              Set NULL to use the default CryptoAPI package, Microsoft RSA 
//              Base Cryptographic Provider v. 1.0. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPSecurityDesc::FGetCAPIProviderA()
{
if ((LPSTR)fCAPIProviderA.c_str()!=fDPSECURITYDESC.lpszCAPIProviderA)
    fCAPIProviderA = fDPSECURITYDESC.lpszCAPIProviderA;
return fCAPIProviderA;
}
// --------------------------------------------------------------------------
void __fastcall TDPSecurityDesc::FSetCAPIProviderA( AnsiString pCAPIProviderA )
{
fCAPIProviderA = pCAPIProviderA;
fDPSECURITYDESC.lpszCAPIProviderA = (LPSTR) fCAPIProviderA.c_str();
}
// --------------------------------------------------------------------------
// Property:    CAPIProviderType
// Description: The CAPIProviderType property defines the CryptoAPI service 
//              provider type to use for encryption. 
//              
//              Set zero to use the default type, PROV_RSA_FULL. 
// --------------------------------------------------------------------------
dword __fastcall TDPSecurityDesc::FGetCAPIProviderType()
{
return fDPSECURITYDESC.dwCAPIProviderType;
}
// --------------------------------------------------------------------------
void __fastcall TDPSecurityDesc::FSetCAPIProviderType( dword pCAPIProviderType )
{
fDPSECURITYDESC.dwCAPIProviderType = pCAPIProviderType;
}
// --------------------------------------------------------------------------
// Property:    EncryptionAlgorithm
// Description: The EncryptionAlgorithm property defines which encryption 
//              algorithm to use. 
//              
//              Stream ciphers are the only types of encryption algorithms 
//              that are supported. 
//              Set zero to use the default algorithm, the CALG_RC4 stream 
//              cipher. 
// --------------------------------------------------------------------------
dword __fastcall TDPSecurityDesc::FGetEncryptionAlgorithm()
{
return fDPSECURITYDESC.dwEncryptionAlgorithm;
}
// --------------------------------------------------------------------------
void __fastcall TDPSecurityDesc::FSetEncryptionAlgorithm( dword pEncryptionAlgorithm )
{
fDPSECURITYDESC.dwEncryptionAlgorithm = pEncryptionAlgorithm;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDPSecurityDesc method or 
//              fget/fset. eg. DP_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDPSecurityDesc::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDPSecurityDesc::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    SSPIProvider
// Description: The SSPIProvider property references a unicode string 
//              identifying the SSPI package to use for authenticating 
//              logins. 
//              
//              Set NULL to use the default SSPI package, NT LAN Manager 
//              security provider. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPSecurityDesc::FGetSSPIProvider()
{
if ((LPWSTR)fSSPIProvider.c_str()!=fDPSECURITYDESC.lpszSSPIProvider)
    fSSPIProvider = fDPSECURITYDESC.lpszSSPIProvider;
return fSSPIProvider;
}
// --------------------------------------------------------------------------
void __fastcall TDPSecurityDesc::FSetSSPIProvider( AnsiString pSSPIProvider )
{
fSSPIProvider = pSSPIProvider;
fDPSECURITYDESC.lpszSSPIProvider = (LPWSTR) fSSPIProvider.c_str();
}
// --------------------------------------------------------------------------
// Property:    SSPIProviderA
// Description: The SSPIProviderA property references an ANSI string 
//              identifying the SSPI package to use for authenticating 
//              logins. 
//              
//              Set NULL to use the default SSPI package, NT LAN Manager 
//              security provider. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDPSecurityDesc::FGetSSPIProviderA()
{
if ((LPSTR)fSSPIProviderA.c_str()!=fDPSECURITYDESC.lpszSSPIProviderA)
    fSSPIProviderA = fDPSECURITYDESC.lpszSSPIProviderA;
return fSSPIProviderA;
}
// --------------------------------------------------------------------------
void __fastcall TDPSecurityDesc::FSetSSPIProviderA( AnsiString pSSPIProviderA )
{
fSSPIProviderA = pSSPIProviderA;
fDPSECURITYDESC.lpszSSPIProviderA = (LPSTR) fSSPIProviderA.c_str();
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DPSECURITYDESC structure. 
// --------------------------------------------------------------------------
dword __fastcall TDPSecurityDesc::FGetSize()
{
return fDPSECURITYDESC.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDPSecurityDesc::FSetSize( dword pSize )
{
fDPSECURITYDESC.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDPSecurityDesc's internal DPSECURITYDESC structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDPSecurityDesc::Clear()
{
fDPSECURITYDESC.dwCAPIProviderType = 0;
fDPSECURITYDESC.dwEncryptionAlgorithm = 0;
fErrorValue = DP_OK;
fDPSECURITYDESC.dwSize = sizeof(DPSECURITYDESC);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DPSECURITYDESC* __fastcall TDPSecurityDesc::FGetInternal_DPSECURITYDESC_Ptr()
{
return &fDPSECURITYDESC;
}
// --------------------------------------------------------------------------
void __fastcall TDPSecurityDesc::FSetInternal_DPSECURITYDESC( DPSECURITYDESC* pDPSECURITYDESC )
{
if (pDPSECURITYDESC==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDPSecurityDesc::FSetInternal_DPSECURITYDESC()", "TDX_ERROR", "The supplied DPSECURITYDESC* was NULL" );
    return;
    }

CopyMemory( &fDPSECURITYDESC, pDPSECURITYDESC, sizeof(DPSECURITYDESC) );
Internal_DPSECURITYDESC_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDPSecurityDesc::Internal_DPSECURITYDESC_Update()
{
}

// --------------------------------------------------------------------------
